{% extends 'views/components/iiif-annotation.htm' %}
{% load i18n %}

{% block workbench %}
<div class='loading-mask' data-bind="visible: $data.savingTile()"></div>
<div class="afs-saving-message" data-bind="visible: $data.savingTile(), text: savingMessage"></div>
<!-- ko if: $data.hasExternalCardData() -->
    <!-- ko with: $data, as: 'self' -->
        {{ block.super }}
    <!-- /ko -->
<!-- /ko -->
{% endblock workbench %}

{% block tabs %}
    <div class="workbench-card-sidebar-tab" data-bind="click: function() {
        toggleTab('dataset');
    }, css: {
        'active': activeTab() === 'dataset'
    }">
        <i class="fa fa-file"></i>
        <span class="map-sidebar-text">{% trans 'Dataset' %}</span>
    </div>
{{ block.super }}

{% endblock tabs %}

{% block sidepanel %}
    <!-- ko if: $data.activeTab() === 'dataset' -->

    <div class="workbench-card-sidepanel-header-container">
        <h4 class="workbench-card-sidepanel-header" data-bind="click: hideSidePanel, text: 'Sample Details'"></h4>
    </div>
    <div class="workbench-card-sidepanel-border"></div>
<div class="workbench-card-sidepanel-body">

    <div data-bind="css: card.model.cssclass">
        <div class="new-provisional-edit-card-container">
            <div class="card">
                <div style="padding: 10px 0; margin-top: 10px;">
                    <h5>{% trans 'Sample locations' %}</h5>
            
                    <div style="margin-left: 5px; margin-right: 15px;">
                        <input 
                            type="text" 
                            placeholder="{% trans 'filter...' %}"
                            style="
                                width: 100%;
                                height: 36px;
                                border: 1px solid #ddd;
                                margin-bottom: 3px;
                            "
                            data-bind="textInput: $data.sampleLocationFilterTerm"
                        >

                        <div
                            style="
                                height: 100px;
                                border: 1px solid #ddd;
                                overflow-y: scroll;
                            "
                        >
                            <table
                                style="
                                    display: flex;
                                    flex-direction: column;
                                    width: 100%;
                                "
                            >
                                <tbody
                                    class="dataset-table"
                                    style="
                                        display: flex;
                                        flex-direction: column;
                                    "
                                >
                                    <!-- ko foreach: $data.filteredSampleLocationInstances -->
                                        <tr
                                            style="cursor: pointer;"
                                            data-bind="
                                                scrollTo: $parent.selectedSampleLocationInstance() && $parent.selectedSampleLocationInstance().tileid === $data.tileid,
                                                click: function() { $parent.selectSampleLocationInstance($data); },
                                                style: {
                                                    background: (function() {
                                                        if ($parent.selectedSampleLocationInstance() && $parent.selectedSampleLocationInstance().tileid === $data.tileid) {
                                                            return '#afd7f7';
                                                        }
                                                    })()
                                                },
                                            "
                                        >
                                            <td class="afs-workflow-table-contents"
                                                data-bind="text: (function(){
                                                    var partIdentifierAssignmentLabelNodeId = '3e541cc6-859b-11ea-97eb-acde48001122';
                                                    return $data.data[partIdentifierAssignmentLabelNodeId]() + ' [Sample of ' + $parent.environmentName + ']';
                                                })()"
                                                style="width: 100%"
                                            ></td>
                                            <td data-bind="if: $parent.samplingActivityResourceId != $data.samplingActivityResourceId()"><i class="fa fa-lock"></i></td>
                                        </tr>
                                    <!-- /ko -->
                                </tbody>
                            </table>
                        </div>
        
                        <button
                            type="button"
                            class="btn"
                            style="
                                margin-top: 6px;
                                background: #9490EE;
                                color: #eee;
                                width: 100%;
                            "
                            data-bind="
                                click: $data.loadNewSampleLocationTile,
                                attr: {
                                    class: ( $data.selectedSampleLocationInstance() && !$data.selectedSampleLocationInstance().tileid ) ? 'btn disabled' : 'btn'
                                }
                            "
                        >
                            <i class="fa fa-folder"></i>
                            <span>
                                {% trans 'Add New Sample' %}
                            </span>
                        </button>
                    </div>
                </div>

                <!-- ko if: $data.selectedSampleLocationInstance() -->
                {% block form_widgets %}
                    <form class="widgets" style="margin-bottom: 20px; margin-top: 10px; margin-left: 5px;">
                        <!-- BEGIN geometry table -->
                        <div data-bind="foreach: {
                            data:card.widgets, as: 'widget'
                        }">
                        <!-- ko if: ko.unwrap(self.form.nodeLookup[widget.node_id()].datatype) === 'annotation' -->
                            <h5 class="analysis-areas-annotation-step-widget-title">
                                {% trans 'Sample Location' %} <span class="afs-workflow-required-tag">{% trans 'required' %}</span>
                            </h5>

                            <i style="display: none;" data-bind="css: {'ion-asterisk widget-label-required': self.form.nodeLookup[widget.node_id()].isrequired}"></i>

                            <div class="col-xs-12" style="width: 342px;">
                                <div class="style-tools-collapser" data-bind=" click: function() {
                                    self.showStylingTools(!self.showStylingTools());
                                }">
                                    <span data-bind="text: self.showStylingTools() ? '{% trans "Hide Style Tools" %}' : '{% trans "Show Style Tools" %}'"></span>
                                    <i class="fa" data-bind="{
                                        css: {
                                            'fa-caret-down' : !self.showStylingTools(),
                                            'fa-caret-up' : self.showStylingTools(),
                                        }
                                    }"></i>
                                </div>
                                <div class="form-horizontal" data-bind="if: self.showStylingTools">
                                    <div class="style-tools-panel">
                                        <div class="form-group">
                                            <label class="col-sm-4 control-label">{% trans "Line Color" %}</label>
                                            <div class="col-sm-8">
                                                <div class="colorpicker-component input-group">
                                                    <input placeholder="{% trans "Line Color " %}" class="form-control input-md widget-input" data-bind="colorPicker: {color: self.lineColor, format:'hex'}">
                                                    <span class="input-group-addon style-tools-color-visualizer" data-bind="style: {background: self.lineColor}"></span>
                                                </div>
                                            </div>
                                        </div>
                                        <div class="form-group">
                                            <label class="col-sm-4 control-label">{% trans "Fill color" %}</label>
                                            <div class="col-sm-8">
                                                <div class="colorpicker-component input-group">
                                                    <input placeholder="{% trans "Fill Color " %}" class="form-control input-md widget-input" data-bind="colorPicker: {color: self.fillColor, format:'hex'}">
                                                    <span class="input-group-addon style-tools-color-visualizer" data-bind="style: {background: self.fillColor}"></span>
                                                </div>
                                            </div>
                                        </div>
                                        <div class="form-group">
                                            <label class="col-sm-4 control-label">{% trans "Line Width" %}</label>
                                            <div class="col-sm-8">
                                                <input type="number" placeholder="" class="form-control" data-bind="valueUpdate: 'keyup', value: self.lineWidth">
                                            </div>
                                        </div>
                                        <div class="form-group">
                                            <label class="col-sm-4 control-label">{% trans "Line Opacity" %}</label>
                                            <div class="col-sm-8">
                                                <input type="number" placeholder="" class="form-control" data-bind="valueUpdate: 'keyup', value: self.lineOpacity">
                                            </div>
                                        </div>
                                        <div class="form-group">
                                            <label class="col-sm-4 control-label">{% trans "Point Radius" %}</label>
                                            <div class="col-sm-8">
                                                <input type="number" placeholder="" class="form-control" data-bind="valueUpdate: 'keyup', value: self.pointRadius">
                                            </div>
                                        </div>
                                        <div class="form-group">
                                            <label class="col-sm-4 control-label">{% trans "Fill Opacity" %}</label>
                                            <div class="col-sm-8">
                                                <input type="number" placeholder="" class="form-control" data-bind="valueUpdate: 'keyup', value: self.fillOpacity">
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="map-card-feature-list">
                                    <div 
                                        class="add-new-feature" 
                                        data-bind="
                                            visible: !self.disableDrawing() && 
                                                    (widget.config.multiFeature() || 
                                                    (!widget.config.multiFeature() && 
                                                        (self.selectedSampleLocationInstanceFeatures() === undefined || 
                                                         self.selectedSampleLocationInstanceFeatures().length < 1))),
                                            click: self.clearEditedGeometries,
                                        "
                                    >
                                        <select data-placeholder="{% trans "Add a new feature..." %}" data-bind="
                                            value: self.featureLookup[widget.node_id()].selectedTool,
                                            valueAllowUnset: true,
                                            options: [
                                                {
                                                    value: '',
                                                    text: ''
                                                },
                                                {
                                                    value: 'draw_point',
                                                    text: 'Add point'
                                                },
                                                {
                                                    value: 'draw_line_string',
                                                    text: 'Add line'
                                                },
                                                {
                                                    value: 'draw_polygon',
                                                    text: 'Add polygon'
                                                }
                                            ],
                                            optionsText: 'text',
                                            optionsValue: 'value',
                                            chosen: {
                                                'width': '100%',
                                                'disable_search_threshold': 10,
                                                'allow_single_deselect': true
                                            }
                                        "></select>
                                    </div>
                                    <div class="add-new-feature" data-bind="visible: !self.sampleLocationDisabled() && self.disableDrawing">
                                        <select data-placeholder="{% trans "Add a new feature..." %}" data-bind="
                                            value: self.featureLookup[widget.node_id()].selectedTool,
                                            valueAllowUnset: true,
                                            options: [
                                                {
                                                    value: '',
                                                    text: ''
                                                },
                                                {
                                                    value: 'draw_point',
                                                    text: 'Add point'
                                                },
                                                {
                                                    value: 'draw_line_string',
                                                    text: 'Add line'
                                                },
                                                {
                                                    value: 'draw_polygon',
                                                    text: 'Add polygon'
                                                }
                                            ],
                                            optionsText: 'text',
                                            optionsValue: 'value',
                                            chosen: {
                                                disabled: true,
                                                'width': '100%',
                                                'disable_search_threshold': 10,
                                                'allow_single_deselect': true
                                            }
                                        "></select>
                                    </div>
                                </div>
                                <table class="table">
                                    <tbody>
                                        <!-- ko foreach: {data: self.selectedSampleLocationInstanceFeatures, as: 'feature'} -->
                                        <tr class="map-card-feature-item" data-bind="css: {'active': self.selectedFeatureIds().indexOf(feature.id) >= 0}, click: function() { self.showFeature(ko.toJS(feature)); }">
                                            <td>
                                                <span class="map-card-feature-name" data-bind="text: feature.geometry.type"></span>
                                            </td>
                                            <td class="map-card-feature-tool" data-bind="visible: !self.sampleLocationDisabled()">
                                                <a href="javascript:void(0);" data-bind="click: function() { self.editFeature(feature); }, clickBubble: false">
                                                    <i class="fa fa-pencil map-card-feature-edit"></i>
                                                    {% trans "Edit" %}
                                                </a>
                                            </td>
                                            <td class="map-card-feature-tool" data-bind="visible: !self.sampleLocationDisabled()">
                                                <a href="javascript:void(0);" data-bind="click: function() { self.deleteFeature(feature); }, clickBubble: false">
                                                    <i class="fa fa-trash map-card-feature-delete"></i>
                                                    {% trans "Delete" %}
                                                </a>
                                            </td>
                                        </tr>
                                        <!-- /ko -->
                                    </tbody>
                                </table>
                            </div>
                        <!-- /ko -->
                        </div>
                        <!-- END geometry table -->

                        <!-- ko if: $data.partIdentifierAssignmentLabelWidget() -->
                            <h5 class="analysis-areas-annotation-step-widget-title" style="margin-bottom: 5px;">
                                {% trans 'Sample Name' %} <span class="afs-workflow-required-tag">{% trans 'required' %}</span>
                            </h5>
                            <i style="display: none;" data-bind="css: {'ion-asterisk widget-label-required': self.form.nodeLookup[$data.partIdentifierAssignmentLabelWidget().node_id()].isrequired}"></i>
                            <div class="afs-sample-name"
                                data-bind='
                                    component: {
                                        name: self.form.widgetLookup[$data.partIdentifierAssignmentLabelWidget().widget_id()].name,
                                        params: {
                                            formData: self.environmentPartIdentifierAssignmentTile().formData,
                                            tile: self.environmentPartIdentifierAssignmentTile(),
                                            form: self.form,
                                            config: $data.partIdentifierAssignmentLabelWidget().configJSON,
                                            label: $data.partIdentifierAssignmentLabelWidget().label(),
                                            value: self.environmentPartIdentifierAssignmentTile().data[$data.partIdentifierAssignmentLabelWidget().node_id()],
                                            node: self.form.nodeLookup[$data.partIdentifierAssignmentLabelWidget().node_id()],
                                            expanded: self.expanded,
                                            graph: self.form.graph,
                                            type: "resource-editor",
                                            disabled: $data.sampleLocationDisabled || (!self.card.isWritable && !self.preview),
                                        }
                                    }, 
                                    css:{
                                        "active": $data.partIdentifierAssignmentLabelWidget().selected,
                                        "hover": $data.partIdentifierAssignmentLabelWidget().hovered,
                                        "$data.partIdentifierAssignmentLabelWidget()-preview": self.preview
                                    }, 
                                    click: function(data, e) {
                                        if (!$data.partIdentifierAssignmentLabelWidget().selected() && self.preview) $data.partIdentifierAssignmentLabelWidget().selected(true);
                                    }, 
                                    event: {
                                        mouseover: function(){
                                            if (self.preview) $data.partIdentifierAssignmentLabelWidget().hovered(true);
                                        },
                                        mouseout: function(){
                                            if (self.preview) $data.partIdentifierAssignmentLabelWidget().hovered(null);
                                        }
                                    }, 
                                    visible: $data.partIdentifierAssignmentLabelWidget().visible
                                '
                            ></div>
                            <div>
                                <input class="afs-calculated-name" disabled type="text" data-bind="textInput: sampleName"></input>
                            </div>
                        <!-- /ko -->

                        <!-- BEGIN sample description -->
                            <h5 class="analysis-areas-annotation-step-widget-title">{% trans 'Sample Description' %}</h5>

                            <div class="afs-workflow-sample-desc" style="margin-left: -21px; margin-top: -18px;"
                                data-bind='
                                    component: {
                                        name: "rich-text-widget",
                                        params: {
                                            renderContext: "workflow",
                                            disabled: $data.sampleLocationDisabled,
                                            value: $data.sampleDescriptionWidgetValue,
                                        }
                                    }, 

                                '
                            ></div>
                        <!-- END sample description -->

                        <!-- BEGIN motivation for sampling -->
                            <h5 class="analysis-areas-annotation-step-widget-title">{% trans 'Motivation for taking this sample' %}</h5>
                            <div class="afs-workflow-sample-desc" style="margin-left: -21px; margin-top: -18px;"
                                data-bind='
                                    component: {
                                        name: "rich-text-widget",
                                        params: {
                                            renderContext: "workflow",
                                            disabled: $data.sampleLocationDisabled,
                                            value: $data.motivationForSamplingWidgetValue,
                                        }
                                    }, 

                                '
                            ></div>
                        <!-- END motivation for sampling -->
                    </form>
                {% endblock form_widgets %}
                <!-- /ko -->

            </div>
        </div>
    </div>
    </div>
    {% block form_buttons %}
    <div class="workbench-button-panel">
        <button 
            class="btn btn-success" 
            data-bind="click: $data.saveSampleLocationTile, css: {disabled: !$data.tileDirty()}"
        >
            <i class="ion-android-cloud-done"></i>
            <span style="padding-left: 4px">{% trans 'Save' %}</span>
        </button>
        <button 
            class="btn btn-danger" 
            data-bind="click: $data.resetSampleLocationTile, css: {disabled: !$data.tileDirty()}"
        >
            <i class="ion-android-cancel"></i>
            <span style="padding-left: 4px">{% trans 'Cancel' %}</span>
        </button>
    </div>
    {% endblock form_buttons %}
    <!-- /ko -->

    {{ block.super }}
{% endblock sidepanel %}
